#include "StdAfx.h"
#include "TileImageShape.h"
#include "ScriptletConstant.h"

REGISTER_COMPONENT_CREATOR(SCRIPTLET_TILEIMAGE_NODE, CTileImageShape);
void CTileImageShape::DrawComponent(HDC hDC)
{
	if (m_pImage)
	{
		int nWidthOfImage = m_pImage->GetWidth();
		int nHeightOfImage = m_pImage->GetHeight();
		if (nHeightOfImage > 0 && nWidthOfImage > 0)
		{
			CRect rcBound(0, 0, nWidthOfImage, nHeightOfImage);
			CRect rcClient;
			GetDrawingBounds(&rcClient);

			int nCountOfHorizontal = min(1024, rcClient.Width() / nWidthOfImage);
			int nCountOfVertical = min(1024, rcClient.Height() / nHeightOfImage);

			CRect rcImage;
			for (int i=0; i<nCountOfHorizontal; i++)
			{
				for (int j=0; j<nCountOfVertical; j++)
				{
					rcImage.left = i * nWidthOfImage;
					rcImage.top = j * nHeightOfImage;
					rcImage.right = rcImage.left + nWidthOfImage;
					rcImage.bottom = rcImage.top + nHeightOfImage;

					m_pImage->DrawImage(hDC, &rcBound, &rcImage);
				}
			}			
		}		
	}
}
